f = double(rgb2gray(imread('George.jpg')));
f = f(1:420,1:630);

F = fftshift(fft2(f));
figure(1);
subplot(311);imagesc(f);axis image;colormap copper;axis off;colorbar
subplot(312);imagesc(abs(F));axis image;colormap copper;colorbar;axis off
subplot(313);imagesc(log(1+abs(F)));axis image;colormap copper;colorbar;axis off


%%
 

k1_dc = 211;
k2_dc = 316;

Fa = F;
Fa(k1_dc,k2_dc) = 0;
fa = (ifft2(fftshift(Fa)));
figure(3);
subplot(221);imagesc(log(1+abs(F)));axis image;colormap copper;colorbar;axis off
title('fft of george');
subplot(222);imagesc(log(1+abs(Fa)));axis image;colormap copper;colorbar;axis off
title('modified fft of george');
subplot(223);imagesc(f,[-110,255]);axis image;colormap copper;colorbar;axis off
title('george');
subplot(224);imagesc(real(fa),[-110,255]);axis image;colormap copper;colorbar;axis off
title('modified george');



%%

Fa = F;
Fa(k1_dc,:) = 0;
fa = (ifft2(fftshift(Fa)));
figure(3);
subplot(221);imagesc(log(1+abs(F)));axis image;colormap copper;colorbar;axis off
title('fft of george');
subplot(222);imagesc(log(1+abs(Fa)));axis image;colormap copper;colorbar;axis off
title('modified fft of george');
subplot(223);imagesc(f);axis image;colormap copper;colorbar;axis off
title('george');
subplot(224);imagesc(real(fa));axis image;colormap copper;colorbar;axis off
title('modified george');



%%

Fa = F;
Fa(:,k2_dc) = 0;
fa = (ifft2(fftshift(Fa)));
figure(3);
subplot(221);imagesc(log(1+abs(F)));axis image;colormap copper;colorbar;axis off
title('fft of george');
subplot(222);imagesc(log(1+abs(Fa)));axis image;colormap copper;colorbar;axis off
title('modified fft of george');
subplot(223);imagesc(f);axis image;colormap copper;colorbar;axis off
title('george');
subplot(224);imagesc(real(fa));axis image;colormap copper;colorbar;axis off
title('modified george');


%%

Fa = F;
Fa(:,k2_dc) = 0;
Fa(k1_dc,:) = 0;
fa = (ifft2(fftshift(Fa)));
figure(3);
subplot(221);imagesc(log(1+abs(F)));axis image;colormap copper;colorbar;axis off
title('fft of george');
subplot(222);imagesc(log(1+abs(Fa)));axis image;colormap copper;colorbar;axis off
title('modified fft of george');
subplot(223);imagesc(f);axis image;colormap copper;colorbar;axis off
title('george');
subplot(224);imagesc(real(fa));axis image;colormap copper;colorbar;axis off
title('modified george');


%%

Fa = F;
c = 20;
Fa(:,1:k2_dc-c) = 0;
Fa(:,k2_dc+c:end) = 0;
fa = (ifft2(fftshift(Fa)));
figure(3);
subplot(221);imagesc(log(1+abs(F)));axis image;colormap copper;colorbar;axis off
title('fft of george');
subplot(222);imagesc(log(1+abs(Fa)));axis image;colormap copper;colorbar;axis off
title('modified fft of george');
subplot(223);imagesc(f);axis image;colormap copper;colorbar;axis off
title('george');
subplot(224);imagesc(real(fa));axis image;colormap copper;colorbar;axis off
title('modified george');

%%

Fa = F;
c = 5;
Fa(1:k1_dc-c,:) = 0;
Fa(k1_dc+c:end,:) = 0;
fa = (ifft2(fftshift(Fa)));
figure(3);
subplot(221);imagesc(log(1+abs(F)));axis image;colormap copper;colorbar;axis off
title('fft of george');
subplot(222);imagesc(log(1+abs(Fa)));axis image;colormap copper;colorbar;axis off
title('modified fft of george');
subplot(223);imagesc(f);axis image;colormap copper;colorbar;axis off
title('george');
subplot(224);imagesc(real(fa));axis image;colormap copper;colorbar;axis off
title('modified george');

%%

Fa = F;
c = 20;
Fa(1:k1_dc-c,:) = 0;
Fa(k1_dc+c:end,:) = 0;
Fa(:,1:k2_dc-c) = 0;
Fa(:,k2_dc+c:end) = 0;
fa = (ifft2(fftshift(Fa)));
figure(3);
subplot(221);imagesc(log(1+abs(F)));axis image;colormap copper;colorbar;axis off
title('fft of george');
subplot(222);imagesc(log(1+abs(Fa)));axis image;colormap copper;colorbar;axis off
title('modified fft of george');
subplot(223);imagesc(f);axis image;colormap copper;colorbar;axis off
title('george');
subplot(224);imagesc(real(fa));axis image;colormap copper;colorbar;axis off
title('modified george');


%%

Fa = F;
c = 20;
Fa(k1_dc-c:k1_dc+c,k2_dc-c:k2_dc+c) = 0;
fa = (ifft2(fftshift(Fa)));
figure(3);
subplot(221);imagesc(log(1+abs(F)));axis image;colormap copper;colorbar;axis off
title('fft of george');
subplot(222);imagesc(log(1+abs(Fa)));axis image;colormap copper;colorbar;axis off
title('modified fft of george');
subplot(223);imagesc(f);axis image;colormap copper;colorbar;axis off
title('george');
subplot(224);imagesc(real(fa));axis image;colormap copper;colorbar;axis off
title('modified george');


%%
Fa = abs(F).*exp(1j*2*pi*rand(size(F)));
fa = (ifft2(fftshift(Fa)));
figure(3);
subplot(221);imagesc(log(1+abs(F)));axis image;colormap copper;colorbar;axis off
title('fft of george');
subplot(222);imagesc(log(1+abs(Fa)));axis image;colormap copper;colorbar;axis off
title('modified fft of george -- original amplitudes, random phases');
subplot(223);imagesc(f);axis image;colormap copper;colorbar;axis off
title('george');
subplot(224);imagesc(abs(fa));axis image;colormap copper;colorbar;axis off
title('modified george');

%%
Fa = F./abs(F).*rand(size(F));
fa = (ifft2(fftshift(Fa)));
figure(3);
subplot(221);imagesc(log(1+abs(F)));axis image;colormap copper;colorbar;axis off
title('fft of george');
subplot(222);imagesc(log(1+abs(Fa)));axis image;colormap copper;colorbar;axis off
title('modified fft of george -- original phases, random amplitudes');
subplot(223);imagesc(f);axis image;colormap copper;colorbar;axis off
title('george');
subplot(224);imagesc(abs(fa));axis image;colormap copper;colorbar;axis off
title('modified george');


