f = double(imread('cameraman.bmp'));

for k = [3 5 9 15 39]
    w = ones(k)/k^2;
    g = conv2(f,w,'same');
    figure(1);imagesc(g,[0,255]);
    axis image; colormap gray; axis off
    title(['k = ' num2str(k)]);
    pause;
end


fn = f+randn(size(f))*0;
figure(1);imagesc(fn,[0 255]);axis image;colormap gray;axis off

for k = [3 5 9 15 39]
    w1 = ones(k)/k^2;
    g1 = conv2(fn,w1,'same');
    w2 = fspecial('gaussian',[k,k],k/3);
    g2 = conv2(fn,w2,'same');

    figure(2);imagesc([g1 g2],[0 255]);axis image;colormap gray;axis off;
    title(['k = ' num2str(k)]);
    pause;
end



